#!/bin/bash


SVFS="/proc/sys/net/unix/share_via_fs"
SOCK="/dev/log"
SOCAT="$(which socat)"
UNSHARE="$(which unshare) -muin"
BASH="$(which bash)"
TESTSCRIPT="$SOCAT -v - unix-sendto:${SOCK} << EOF
1
2
3
EOF"


# check
[ -f $SVFS ] || {
	echo "${SVFS} doesn't exist or isn't a file"
	exit 1
}
[ -S $SOCK ] || {
	echo "${SOCK} doesn't exist or isn't a socket"
	exit 2
}

echo "* step 1: diable share via fs"

echo "0" > $SVFS || {
	echo "something went wrong trying to disable ${SVFS}"
	exit 3	
}

# root ns - this should work
$BASH -c exec $TESTSCRIPT || {
	echo "something went went wrong trying to execute ${TESTSCRIPT}"
	exit 4
}

# child ns - this shouldn't work
$UNSHARE $BASH << EOF
exec $TESTSCRIPT
EOF

[ $? -eq 0 ] && {
	echo "this shouldn't be possible ;-)"
	exit 5
}

echo "* step 1: ok"


echo "* step 2: enable share via fs"
echo "1" > $SVFS

# root ns - this should work
$BASH -c exec $TESTSCRIPT || {
	echo "something went went wrong trying to execute ${TESTSCRIPT}"
	exit 6
}

# child ns - this should work now !
$UNSHARE $BASH << EOF
exec $TESTSCRIPT
EOF

[ $? -eq 0 ] || {
	echo "access to socket isn't possile though share_via_fs is enabled"
	exit 7
}

echo "* step 2: ok - test successfull"

exit 0
